/*
 * instr.h
 *
 *  Created on: Oct 8, 2015
 *      Author: heso
 */

#ifndef INSTR_H_
#define INSTR_H_

#include "glob.h"
#include "condReg.h"

void andi 	(unsigned int regd, unsigned int imm);
void and  	(unsigned int regd, unsigned int rega);
void ori  	(unsigned int regd, unsigned int imm);
void or   	(unsigned int regd, unsigned int rega);
void xor  	(unsigned int regd, unsigned int rega);
void xori 	(unsigned int regd, unsigned int imm);

void lsr  	(unsigned int regd, unsigned int imm);
void lsl  	(unsigned int regd, unsigned int imm);

void ldi  	(unsigned int regd, unsigned int imm);
void mov	(unsigned int regd, unsigned int rega);

void som  	(io_t padCtrl, unsigned int addr, unsigned int reg);
void sol  	(io_t padCtrl, unsigned int addr, unsigned int reg);
void sim  	(unsigned int addr, unsigned int reg);
void sil  	(unsigned int addr, unsigned int reg);

void repeat(unsigned int iter, void (*section)());

void jmp 	(void (*section)());

void timst 	(unsigned int time);
void wfe	(void);
void nop	(void);

void in		(unsigned int reg);
void out	(io_t padCtrl, unsigned int reg);
void outi	(io_t padCtrl, unsigned int imm);

void cpse 	(unsigned int regd, unsigned int imm);
void cpseLogic(unsigned int rega, unsigned int imm, void (*logicFunc)(unsigned int, unsigned int), unsigned int var1, unsigned int var2);
void cpsneLogic(unsigned int rega, unsigned int imm, void (*logicFunc)(unsigned int, unsigned int), unsigned int var1, unsigned int var2);
int  cpseJmp(unsigned int rega, unsigned int imm, void (*jmpFunc)(), void (*section)());
int  cpsneJmp(unsigned int rega, unsigned int imm, void (*jmpFunc)(), void (*section)());

void cbse 	(unsigned int regd, unsigned int bit, unsigned int boolean);
int cbseJmp(unsigned int rega, unsigned int bit, unsigned int boolean, void (*jmpFunc)(), void (*section)());
void jmpDummy(char* location);

//==============CONDITIONALS================

void cpiec(condReg_t condReg, unsigned int reg, unsigned int imm, unsigned int cond);
void cpinec(condReg_t condReg, unsigned int reg, unsigned int imm, unsigned int cond);
void cpibec(condReg_t condReg, unsigned int reg, unsigned int bit, unsigned int boolean, unsigned int cond);

void setc(unsigned int cReg, unsigned int cond);
void clrc(unsigned int cReg, unsigned int cond);

void inc(unsigned int reg, unsigned int cond);
void outc(io_t padCtrl, unsigned int reg, unsigned int cond);
void outic(io_t padCtrl, unsigned int imm, unsigned int cond);

void andic(unsigned int regd, unsigned int imm, unsigned int cond);
void andc(unsigned int regd, unsigned int rega, unsigned int cond);
void oric(unsigned int regd, unsigned int imm, unsigned int cond);
void orc(unsigned int regd, unsigned int rega, unsigned int cond);
void xorc(unsigned int regd, unsigned int rega, unsigned int cond);
void xoric(unsigned int regd, unsigned int imm, unsigned int cond);

void lsrc(unsigned int regd, unsigned int imm, unsigned int cond);
void lslc(unsigned int regd, unsigned int imm, unsigned int cond);

void ldic(unsigned int regd, unsigned int imm, unsigned int cond);
void movc(unsigned int regd, unsigned int rega, unsigned int cond);

void somc(io_t padCtrl, unsigned int addr, unsigned int reg, unsigned int cond);
void solc(io_t padCtrl, unsigned int addr, unsigned int reg, unsigned int cond);
void simc(unsigned int addr, unsigned int reg, unsigned int cond);
void silc(unsigned int addr, unsigned int reg, unsigned int cond);

void repeatc(unsigned int iter, void (*section)(), unsigned int cond);

int jmpc(void (*section)(), unsigned int cond);

void cpsec(unsigned int regd, unsigned int imm, unsigned int cond);
void cpseLogicc(unsigned int rega, unsigned int imm, void (*logicFunc)(unsigned int, unsigned int), unsigned int var1, unsigned int var2, unsigned int cond);
void cpsneLogicc(unsigned int rega, unsigned int imm, void (*logicFunc)(unsigned int, unsigned int), unsigned int var1, unsigned int var2, unsigned int cond);
void cpsneOutc(unsigned int rega, unsigned int imm, void (*outFunc)(), io_t padCtrl, unsigned int immReg, unsigned int cond);
int cpseJmpc(unsigned int rega, unsigned int imm, void (*jmpFunc)(), void (*section)(), unsigned int cond);
int cpsneJmpc(unsigned int rega, unsigned int imm, void (*jmpFunc)(),void (*section)(), unsigned int cond);

void cbsec(unsigned int regd, unsigned int bit, unsigned int boolean, unsigned int cond);
int cbseJmpc(unsigned int rega, unsigned int bit, unsigned int boolean, void (*jmpFunc)(), void (*section)(), unsigned int cond);
int jmpDummyc(char* location, unsigned int cond);

#endif /* INSTR_H_ */
