/*
 * instr.h
 *
 *  Created on: Oct 8, 2015
 *      Author: heso
 */

#ifndef INSTR_H_
#define INSTR_H_

#include "glob.h"
#include "condReg.h"

void andi 	(unsigned int regd, unsigned int imm);
void and  	(unsigned int regd, unsigned int rega);
void ori  	(unsigned int regd, unsigned int imm);
void or   	(unsigned int regd, unsigned int rega);
void xor  	(unsigned int regd, unsigned int rega);
void xori 	(unsigned int regd, unsigned int imm);

void lsr  	(unsigned int regd, unsigned int imm);
void lsl  	(unsigned int regd, unsigned int imm);

void ldi  	(unsigned int regd, unsigned int imm);
void mov	(unsigned int regd, unsigned int rega);

void som  	(io_t padCtrl, unsigned int addr, unsigned int reg);
void sol  	(io_t padCtrl, unsigned int addr, unsigned int reg);
void sim  	(unsigned int addr, unsigned int reg);
void sil  	(unsigned int addr, unsigned int reg);

void repeat(unsigned int iter, void (*section)());

void jmp 	(void (*section)());

void timst 	(unsigned int time);
void wfe	(void);

void in		(unsigned int reg);
void out	(io_t padCtrl, unsigned int reg);
void outi	(io_t padCtrl, unsigned int imm);

void cpse 	(unsigned int regd, unsigned int imm);
void cpseLogic(unsigned int rega, unsigned int imm, void (*logicFunc)(unsigned int, unsigned int), unsigned int var1, unsigned int var2);
void cpsneLogic(unsigned int rega, unsigned int imm, void (*logicFunc)(unsigned int, unsigned int), unsigned int var1, unsigned int var2);
int  cpseJmp(unsigned int rega, unsigned int imm, void (*jmpFunc)(), void (*section)());
int  cpsneJmp(unsigned int rega, unsigned int imm, void (*jmpFunc)(), void (*section)());

void cbse 	(unsigned int regd, unsigned int bit, unsigned int boolean);
int cbseJmp(unsigned int rega, unsigned int bit, unsigned int boolean, void (*jmpFunc)(), void (*section)());
void jmpDummy(char* location);
void nop(void);

//-----------PARALLEL--------------
int parallelEx(
		 void (*ex0)(unsigned int,unsigned int,unsigned int), unsigned int ex0var0, unsigned int ex0var1, unsigned int ex0var2, unsigned int ex0Cond
		,void (*ex1)(unsigned int,unsigned int,unsigned int), unsigned int ex1var0, unsigned int ex1var1, unsigned int ex1var2, unsigned int ex1Cond
		,void (*ex2)(unsigned int,unsigned int,unsigned int), unsigned int ex2var0, unsigned int ex2var1, unsigned int ex2var2, unsigned int ex2Cond
		,void (*ex3)(unsigned int,unsigned int,unsigned int), unsigned int ex3var0, unsigned int ex3var1, unsigned int ex3var2, unsigned int ex3Cond
		);

int parallelEx2Jmp(
		void (*ex0)(void* (section)())  , void (*ex0section)()  , unsigned int ex0Cond
		,void (*ex1)(void* (section)())  , void (*ex1section)()  , unsigned int ex1Cond
		,void (*ex2)(unsigned int,unsigned int,unsigned int), unsigned int ex2var0, unsigned int ex2var1, unsigned int ex2var2, unsigned int ex2Cond
		,void (*ex3)(unsigned int,unsigned int,unsigned int), unsigned int ex3var0, unsigned int ex3var1, unsigned int ex3var2, unsigned int ex3Cond
		);

int parallelExJmp(
		void (*ex0)(void* (section)())  , void (*ex0section)()  , unsigned int ex0Cond
		,void (*ex1)(void* (section)())  , void (*ex1section)()  , unsigned int ex1Cond
		,void (*ex2)(void* (section)())  , void (*ex2section)()  , unsigned int ex2Cond
		,void (*ex3)(void* (section)())  , void (*ex3section)()  , unsigned int ex3Cond
		);

void parDummy(void);
void cpiePar(unsigned int condReg, unsigned int reg, unsigned int imm);
void cpinePar(unsigned int condReg, unsigned int reg, unsigned int imm);
void setPar(unsigned int cReg, unsigned int dummy, unsigned int dummy1);
void clrPar(unsigned int cReg, unsigned int dummy, unsigned int dummy1);
void inPar(unsigned int reg, unsigned int dummy, unsigned int dummy1);
void outPar(unsigned int padCtrl, unsigned int reg, unsigned int dummy);
void outiPar(unsigned int padCtrl, unsigned int imm, unsigned int dummy);
void andiPar(unsigned int regd, unsigned int imm, unsigned int dummy);
void andPar(unsigned int regd, unsigned int rega, unsigned int dummy);
void oriPar(unsigned int regd, unsigned int imm, unsigned int dummy);
void orPar(unsigned int regd, unsigned int rega, unsigned int dummy);
void xorPar(unsigned int regd, unsigned int rega, unsigned int dummy);
void xoriPar(unsigned int regd, unsigned int imm, unsigned int dummy);
void lsrPar(unsigned int regd, unsigned int imm, unsigned int dummy);
void lslPar(unsigned int regd, unsigned int imm, unsigned int dummy);
void ldiPar(unsigned int regd, unsigned int imm, unsigned int dummy);
void movPar(unsigned int regd, unsigned int rega, unsigned int dummy);
void somPar(unsigned int padCtrl, unsigned int addr, unsigned int reg);
void solPar(unsigned int padCtrl, unsigned int addr, unsigned int reg);
void simPar(unsigned int addr, unsigned int reg, unsigned int dummy);
void silPar(unsigned int addr, unsigned int reg, unsigned int dummy);

void jmpDummyPar(char* destination, unsigned int dummy, unsigned int dummy1);
void nopPar(unsigned int dummy1, unsigned int dummy2, unsigned int dummy3);
void cpibe0Par(condReg_t cReg, unsigned int reg, unsigned int bit);
void cpibe1Par(condReg_t cReg, unsigned int reg, unsigned int bit);
void wfePar(unsigned int dummy, unsigned int dummy1, unsigned int dummy2);
void timstPar(unsigned int time, unsigned int dummy, unsigned int dummy1);
int jmpPar(void (*section)(), unsigned int dummy, unsigned int dummy1);

#endif /* INSTR_H_ */
