/*
 * instr.h
 *
 *  Created on: Oct 8, 2015
 *      Author: heso
 */

#ifndef INSTR_H_
#define INSTR_H_

#include "glob.h"

void andi 	(unsigned int regd, unsigned int imm);
void and  	(unsigned int regd, unsigned int rega);
void ori  	(unsigned int regd, unsigned int imm);
void or   	(unsigned int regd, unsigned int rega);
void xor  	(unsigned int regd, unsigned int rega);
void xori 	(unsigned int regd, unsigned int imm);

void lsr  	(unsigned int regd, unsigned int imm);
void lsl  	(unsigned int regd, unsigned int imm);

void ldi   	(unsigned int regd, unsigned int imm);
void mov	(unsigned int regd, unsigned int rega);

void som  	(io_t padCtrl, unsigned int addr, unsigned int reg);
void sol  	(io_t padCtrl, unsigned int addr, unsigned int reg);
void sim  	(unsigned int addr, unsigned int reg);
void sil  	(unsigned int addr, unsigned int reg);

void jmp 	(void (*section)());

void timst 	(unsigned int time);
void wfe	(void);
void nop	(void);

void in		(unsigned int reg);
void out	(io_t padCtrl, unsigned int reg);
void outi	(io_t padCtrl, unsigned int imm);

void cpse 	(unsigned int regd, unsigned int imm);
void cpseLogic(unsigned int rega, unsigned int imm, void (*logicFunc)(unsigned int, unsigned int), unsigned int var1, unsigned int var2);
void cpsneLogic(unsigned int rega, unsigned int imm, void (*logicFunc)(unsigned int, unsigned int), unsigned int var1, unsigned int var2);
int  cpseJmp(unsigned int rega, unsigned int imm, void (*jmpFunc)(), void (*section)());
int  cpsneJmp(unsigned int rega, unsigned int imm, void (*jmpFunc)(), void (*section)());

void cbse 	(unsigned int regd, unsigned int bit, unsigned int boolean);
int cbseJmp(unsigned int rega, unsigned int bit, unsigned int boolean, void (*jmpFunc)(), void (*section)());
void jmpDummy(char* location);

#endif /* INSTR_H_ */
