/*
 * instr.h
 *
 *  Created on: Oct 8, 2015
 *      Author: heso
 */

#ifndef INSTR_H_
#define INSTR_H_

#include "glob.h"

void andi 	(unsigned int regd, unsigned int rega, unsigned int imm);
void and  	(unsigned int regd, unsigned int rega, unsigned int regb);
void ori  	(unsigned int regd, unsigned int rega, unsigned int imm);
void or   	(unsigned int regd, unsigned int rega, unsigned int regb);
void xor  	(unsigned int regd, unsigned int rega, unsigned int regb);
void xori 	(unsigned int regd, unsigned int rega, unsigned int imm);

void lsr  	(unsigned int regd, unsigned int rega, unsigned int imm);
void lsl  	(unsigned int regd, unsigned int rega, unsigned int imm);

void ld   	(unsigned int regd, unsigned int addr);
void ldi  	(unsigned int regd, unsigned int imm);
void mov	(unsigned int regd, unsigned int regb);

void jmp 	(void (*section)());

void timst 	(unsigned int time);
void wfe	(void);
void nop	(void);

void in		(unsigned int reg);
void out	(io_t padCtrl, unsigned int reg);
void outi	(io_t padCtrl, unsigned int imm);

void cpse 	(unsigned int regd, unsigned int imm);
void cpse3Op(unsigned int rega, unsigned int imm, void (*logicFunc)(unsigned int, unsigned int, unsigned int), unsigned int var1, unsigned int var2, unsigned int var3);
void cpse2Op(unsigned int rega, unsigned int imm, void (*logicFunc)(unsigned int, unsigned int), unsigned int var1, unsigned int var2);
void cpsne3Op(unsigned int rega, unsigned int imm, void (*logicFunc)(unsigned int, unsigned int, unsigned int), unsigned int var1, unsigned int var2, unsigned int var3);
void cpsne2Op(unsigned int rega, unsigned int imm, void (*logicFunc)(unsigned int, unsigned int), unsigned int var1, unsigned int var2);
int  cpseJmp(unsigned int rega, unsigned int imm, void (*jmpFunc)(), void (*section)());
int  cpsneJmp(unsigned int rega, unsigned int imm, void (*jmpFunc)(), void (*section)());

void cbse 	(unsigned int regd, unsigned int bit, unsigned int boolean);
int cbseJmp(unsigned int rega, unsigned int bit, unsigned int boolean, void (*jmpFunc)(), void (*section)());
void cbse3Op(unsigned int rega, unsigned int bit, unsigned int boolean, void(*logicFunc)(unsigned int, unsigned int, unsigned int), unsigned int var1, unsigned int var2, unsigned int var3);
void cbse2Op(unsigned int rega, unsigned int bit, unsigned int boolean, void(*logicFunc)(unsigned int, unsigned int), unsigned int var1, unsigned int var2);
void jmpDummy(char* location);

#endif /* INSTR_H_ */
