/*
 * glob.h
 *
 *  Created on: Oct 8, 2015
 *      Author: heso
 */

#ifndef GLOB_H_
#define GLOB_H_

typedef enum {IN = 0, OUT, IE, OE_N} io_t;
typedef enum {MSB = 0, LSB} sb_t;
typedef enum {CSn = 4, SCKO, MISO, MOSI} spi_t;
typedef enum {RXD = 6, TXD} uart_t;
typedef enum {SCL=6, SDA} i2c_t;
typedef enum {DO_NOT_USE=6,I2C_STOP=7} i2cCtrl_t;
typedef enum {R0 = 0, R1, R2, R3, REG_SIZE} reg_t;
typedef enum {TXRUN, TXSTART, RXRUN} uartCtrl_t;
typedef enum {SPI_RUNNING, SPI_BYTE_READY} spiCtrl_t;

#define RX_REG REG_SIZE
#define TX_REG RX_REG+1
#define CTRL_REG TX_REG+1

#define NAN 0

#define IO_SIZE 256
#define FLUSH_PENALTY 2
#define CPU_CK_TIME 63//ns ~16MHz 	//Full cycle

//1/2 cycle:
#define SPI_CK_TIME  4000//4000//125kbps   //1000//ns 500kbps //2000//250kbps
#define I2C_CK_TIME  5000//5000//100kbps   //1250//ns 400kbps
#define UART_CK_TIME 4340//115.2kbps //1240//403kbps    //52083//9.6kbps //26042//19.2kbps //6510//76.8kbps //2000//250kbps


void initSim(char const* testName);
void closeSim();
void resetSim();

//report.c::instrNameArray must be updated if instr_t is changed
//instrNameArray[instr_t] should match each other. i.e. instrNameArray[I_IN] = "in"
//Do not remove elements, it will break other tests. List is only intended for reporting purposes.
typedef enum
{
	I_IN,
	I_OUT,
	I_OUTI,
	I_ANDI,
	I_AND,
	I_ORI,
	I_OR,
	I_XOR,
	I_XORI,
	I_LSR,
	I_LSL,
	I_LD,
	I_LDI,
	I_SOM,
	I_SOL,
	I_SIM,
	I_SIL,
	I_CPSE,
	I_CBSE,
	I_REPEAT,
	I_JMP,
	I_TIMST,
	I_WFE,
	I_CLRF,
	I_SETF,
	I_MOV,
	I_CPI,
	I_CPIB,
	I_NOP,
	I_SET,
	I_CLR,
	I_SIZEOF //Should always be the final element
} instr_t;


#endif /* GLOB_H_ */
