/*

 * regfile.c
 *
 *  Created on: Oct 8, 2015
 *      Author: heso
 */
#include "regFile.h" //glob.h included
#include "vcd.h" //glob.h included
#include <stdio.h>
#include <string.h>

#define ALL_REG_SIZE REG_SIZE+3
static unsigned int regFile[ALL_REG_SIZE] = {0,0,0,0,0,0,0};

void regWrite (unsigned int reg, unsigned int val)
{
	if (reg < ALL_REG_SIZE)
	{
		regFile[reg] = val;
		vcdReg(reg, regFile[reg]);
	}
	else
		fprintf(stderr, "regWrite: reg %d does not exist.", reg);
}

unsigned int regRead (unsigned int reg)
{
	if (reg < ALL_REG_SIZE)
	{
		return regFile[reg];
	}
		else
	{
		fprintf(stderr, "regWrite: reg %d does not exist.", reg);
		return 0xDEAD;
	}
}

void regWriteRxReg(sb_t sb, unsigned int val)
{
	if (val)
	{
		//Assume val only contains either MSB or LSB
		regFile[RX_REG] |= val;
		vcdReg(RX_REG, regFile[RX_REG]);
	}
	else if (sb == LSB)
	{
		regFile[RX_REG] &= 0xFE;
		vcdReg(RX_REG, regFile[RX_REG]);
	}
	else if (sb == MSB)
	{
		regFile[RX_REG] &= 0x7F;
		vcdReg(RX_REG, regFile[RX_REG]);
	}
	else
	{
		fprintf(stderr, "regWriteOutRegAndReg: sb was some value other than MSB/LSB.");
	}
}

unsigned int regReadTxReg(sb_t sb)
{
	if(sb == MSB)
	{
		return regFile[TX_REG] & 0x80;
	}
	else if(sb == LSB)
	{
		return regFile[TX_REG] & 0x01;
	}
	else
	{
		fprintf(stderr, "regReadInReg: sb was some value other than MSB/LSB.");
		return 0xDEAD;
	}
}

void regFileReset(void)
{
	memset(regFile, 0, sizeof(regFile));
}

void debugRegWriteBit(unsigned int reg, unsigned int bit, unsigned int boolean)
{
	if (reg < ALL_REG_SIZE)
	{
		if(boolean == 1)
		{
			regFile[reg] |= 1<<bit;
		}
		else if (boolean == 0)
		{
			regFile[reg] &= 0xFF ^ 1<<bit;
		}
		else
			fprintf(stderr, "debugRegWriteBit: boolean = %d, is not a valid boolean value", boolean);

		vcdReg(reg, regFile[reg]);
	}
	else
		fprintf(stderr, "debugRegWriteBit: reg %d does not exist.", reg);
}
